/* 
    Kinimatic Chain Simulator

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2006 Jason Hunt
    nulluser@gmail.gom 
*/
#include <windows.h>
#include <math.h>

#include "kimchain.h"
#include "main.h"

#define MAX_POS     10
#define MAX_BLOCKS  10



kimblock_type blocks[10];           // Kinimatic blocks

unsigned int num_blocks = 7;        // Hardcoded number of blocks

double world_x_size = 12;           // size of 2d world
double world_y_size = 10;


point zero = {0,0}; // Origin point


double positions[MAX_POS][MAX_BLOCKS];

double next_pos [MAX_BLOCKS];
bool move_adjust = false;


/* Hard code the blocks */
void setup_kimchain(HWND hwnd)
{
    
    
    blocks[6].base_points[0].x = -0.25;
    blocks[6].base_points[0].y = -0.25;

    blocks[6].base_points[1].x = 1.55;
    blocks[6].base_points[1].y = -0.25;

    blocks[6].base_points[2].x = 1.55;
    blocks[6].base_points[2].y = 0.25;

    blocks[6].base_points[3].x = -0.25;
    blocks[6].base_points[3].y = 0.25;
    
    blocks[6].x_pos = 0;
    blocks[6].y_pos = 0.75;
    
    blocks[6].angle = 0.0;      
    
//    blocks[6].children[0] = NULL;        
    blocks[6].num_children = 0;    
    
      
    blocks[5].base_points[0].x = -0.25;
    blocks[5].base_points[0].y = -0.25;

    blocks[5].base_points[1].x = 1.55;
    blocks[5].base_points[1].y = -0.25;

    blocks[5].base_points[2].x = 1.55;
    blocks[5].base_points[2].y = 0.25;

    blocks[5].base_points[3].x = -0.25;
    blocks[5].base_points[3].y = 0.25;
    
    blocks[5].x_pos = 0;
    blocks[5].y_pos = -0.75;
    
    blocks[5].angle = 0.0;      
    
    blocks[5].num_children = 0;    
    
    
    blocks[4].base_points[0].x = -0.25;
    blocks[4].base_points[0].y = -1.00;

    blocks[4].base_points[1].x = 0.25;
    blocks[4].base_points[1].y = -1.00;

    blocks[4].base_points[2].x = 0.25;
    blocks[4].base_points[2].y = 1.00;

    blocks[4].base_points[3].x = -0.25;
    blocks[4].base_points[3].y = 1.0;
    
    blocks[4].x_pos = 2.0;
    blocks[4].y_pos = 0;
    
    blocks[4].angle = -0.2;      
    
    blocks[4].children[0] = blocks+5;      
    blocks[4].children[1] = blocks+6;      
    
    blocks[4].num_children = 2;    
     
          
    blocks[3].base_points[0].x = -0.25;
    blocks[3].base_points[0].y = -0.25;

    blocks[3].base_points[1].x = 2.25;
    blocks[3].base_points[1].y = -0.25;

    blocks[3].base_points[2].x = 2.25;
    blocks[3].base_points[2].y = 0.25;

    blocks[3].base_points[3].x = -0.25;
    blocks[3].base_points[3].y = 0.25;
    
    blocks[3].x_pos = 2.0;
    blocks[3].y_pos = 0;
    
    blocks[3].angle = -0.2;      
    
     blocks[3].children[0] = blocks+4; 
  blocks[3].num_children = 1;    

      
    blocks[2].base_points[0].x = -0.25;
    blocks[2].base_points[0].y = -0.25;

    blocks[2].base_points[1].x = 2.25;
    blocks[2].base_points[1].y = -0.25;

    blocks[2].base_points[2].x = 2.25;
    blocks[2].base_points[2].y = 0.25;

    blocks[2].base_points[3].x = -0.25;
    blocks[2].base_points[3].y = 0.25;
    
    blocks[2].x_pos = 3.0;
    blocks[2].y_pos = 0;
    
    blocks[2].angle = -0.2;      
    
    blocks[2].children[0] = blocks+3; 
    blocks[2].num_children = 1;    
  
    
    
    blocks[1].base_points[0].x = -0.25;
    blocks[1].base_points[0].y = -0.25;

    blocks[1].base_points[1].x = 3.25;
    blocks[1].base_points[1].y = -0.25;

    blocks[1].base_points[2].x = 3.25;
    blocks[1].base_points[2].y = 0.25;

    blocks[1].base_points[3].x = -0.25;
    blocks[1].base_points[3].y = 0.25;
    
    blocks[1].x_pos = 1.0;
    blocks[1].y_pos = -1.0;
    
    blocks[1].angle = -0.2;      
    
    blocks[1].children[0]= blocks+2; 
    blocks[1].num_children = 1;    


    blocks[0].x_pos = 1.5;
    blocks[0].y_pos = 8.5;

    blocks[0].base_points[0].x = -1.25;
    blocks[0].base_points[0].y = -1.25;

    blocks[0].base_points[1].x = 1.25;
    blocks[0].base_points[1].y = -1.25;

    blocks[0].base_points[2].x = 1.25;
    blocks[0].base_points[2].y = 1.25;

    blocks[0].base_points[3].x = -1.25;
    blocks[0].base_points[3].y = 1.25;
    
    
    blocks[0].angle = 0;
    
    blocks[0].children[0] = blocks+1;

    blocks[0].num_children = 1;    
}




point rotate(point s, point r_point, double angle)
{
    point r;

    s.x -= r_point.x;
    s.y -= r_point.y;

    r.x = s.x * cos(angle) - s.y * sin(angle) + r_point.x;
    r.y = s.x * sin(angle) + s.y * cos(angle) + r_point.y;
    
    return(r);
}


int get_screen_x(double x)
{
    return((int)(x/world_x_size * display_x));    
}

int get_screen_y(double y)
{
    return((int)(y/world_y_size * display_y));    
}







void calc_kimblock(point base, double base_angle, kimblock_type *b)
{
    point rot_point = {base.x, base.y};    // We will rotate around this point
 
    // rotate and translate the four verticies
    for (int i = 0; i < 4; i++)
    {
        // Rotate about self
        b->rot_points[i] = rotate(b->base_points[i], zero, b->angle);

        // Translate into space of parent and add pos offset
        b->rot_points[i].x += base.x + b->x_pos;
        b->rot_points[i].y += base.y + b->y_pos;

        // rotate into parent space
        b->rot_points[i] = rotate( b->rot_points[i], rot_point, base_angle);
    }   
    
        
    // Translate base by position offset
    base.x += b->x_pos;
    base.y += b->y_pos;  
    
    base = rotate( base, rot_point, base_angle);
    
    // save rotated position
    b->rot_pos.x = base.x;
    b->rot_pos.y = base.y;
    
     // Calculate screen cords
    for (int i = 0; i < 4; i++)
    {
        b->screen_points[i].x = get_screen_x(b->rot_points[i].x);
        b->screen_points[i].y = get_screen_y(b->rot_points[i].y);
    }
 
    for (int i = 0; i < b->num_children; i++)
    if (b->children[i] != NULL)
        calc_kimblock(base, b->angle+base_angle, b->children[i]); 
}



void draw_kimblock(HDC dc,  kimblock_type *b)
{
    Polygon(dc, b->screen_points, 4);

    double joint_size = 0.1;
  
     Ellipse(dc, get_screen_x( b->rot_pos.x-joint_size ), get_screen_y( b->rot_pos.y -joint_size),
               get_screen_x( b->rot_pos.x+joint_size ), get_screen_y( b->rot_pos.y +joint_size));
    
    for (int i = 0; i < b->num_children; i++)
        if (b->children[i] != NULL)
            draw_kimblock(dc, b->children[i]); 
}



void draw_kimchain(HDC dc)
{
    draw_kimblock(dc,  blocks);
}



void calc_kimchain(void)
{
    calc_kimblock(zero, 0, blocks);
}



int find_closest_joint(unsigned int x, unsigned int y)
{
    int closest_index = -1;
    double closest_dist = 500;

    for (int i = 0; i < num_blocks; i++)
    {
        double dist = sqrt((x - get_screen_x(blocks[i].rot_pos.x))*(x - get_screen_x(blocks[i].rot_pos.x)) + 
                      (y - get_screen_y(blocks[i].rot_pos.y))*(y - get_screen_y(blocks[i].rot_pos.y)));

        if (dist < closest_dist)
        {
                closest_dist = dist;
            closest_index = i;    
        }        
        
        
        
    }
            
            return(    closest_index);
}







void save_position(unsigned int pos_number)
{
    for (int i = 0; i < num_blocks; i++)
        positions[pos_number][i] = blocks[i].angle;
}


void move_position(unsigned int pos_number)
{
    double steps = 1000;

    for (int i = 0; i < num_blocks; i++)
    {
        next_pos[i] = positions[pos_number][i];        
        
        move_adjust = true;
                
//     blocks[i].angle = 
//        deltas[i] = (positions[pos_number][i] - blocks[i].angle) / steps;
  
    

     

    }  
  
    
}


void pos_step( void )
{
    
    if (!move_adjust ) return;
        
    
    unsigned int num_done = 0;
    
    
     for (int i = 0; i < num_blocks; i++)
    {
        
        double error =  next_pos[i] - blocks[i].angle;
        
        if (fabs(error) < 0.1) num_done ++;
    
        blocks[i].angle += error/100.0;// * deltas[i];;

    }  
     
    if (num_done == num_blocks) move_adjust =false;
        
    
    
    
}




















