/* 
    Kinimatic Chain Simulator

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2006 Jason Hunt
    nulluser@gmail.gom 
*/


#include <windows.h>

#ifndef KIMCHAIN_H
#define KIMCHAIN_H


typedef struct point
{
    double x;
    double y;
    
};


typedef struct kimblock_type
{
    point base_points[4];           // non rotated inital polygon
    point rot_points[4];            // rotated polygon
    POINT screen_points[4];
    
    double x_pos, y_pos;            // point to rotate around
    
    point rot_pos;  // rotated position
    
    double angle;
    
    kimblock_type *children[10];
    unsigned int num_children;
    
};

void setup_kimchain(HWND hwnd);

void calc_kimchain(void);
void draw_kimchain(HDC dc);

int find_closest_joint(unsigned int x, unsigned int y);

extern kimblock_type blocks[];

int get_screen_x(double x);
int get_screen_y(double y);


void save_position(unsigned int pos_number);
void move_position(unsigned int pos_number);
void pos_step( void );


#endif
