/* 
    Kinimatic Chain Simulator

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2006 Jason Hunt
    nulluser@gmail.gom 
*/

#include <windows.h>

#include <stdio.h>

#include "main.h"
#include "kimchain.h"

#include "math.h"

HDC memdc;                      // Device context for offscreen drawing
HBITMAP mem_bitmap;             // Bitmap for memdc

int display_x, display_y;       // Current Size of the client area

bool keys[256] = { false };     // Key array, true if pressed

int updates = 0;                // Number of updates since last second
int updates_per_second = 0;     // Number of updates per second

int timer_val = 10;


bool mouse_down = false;
int mouse_down_x = 0;
int mouse_down_y = 0;
int joint_index = 0;
double mouse_angle = 0;
double joint_angle = 0;


bool in_save_mode = false;

void write_string(char * str)
{
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        if (!AllocConsole()) return;
        h_console = GetStdHandle(STD_OUTPUT_HANDLE);
        
        if (h_console == INVALID_HANDLE_VALUE) return;        
    }
            
    DWORD num_out;
            
    WriteConsole(h_console, str, strlen(str), &num_out, NULL);
}




/* Init the entire system */
void system_startup( HWND hwnd )
{
//    srand(time(NULL));
    
    memdc_setup(hwnd);
    
    setup_kimchain(hwnd);

//    world_setup();
//
//    world_update();
//    world_draw(memdc);    

    SetTimer(hwnd, UPDATE_ID, timer_val, NULL);        
    SetTimer(hwnd, SECOND_ID, 1000, NULL);        
}
/* End of system_startup */


/* De-Init the entire system */
void system_shutdown( void )
{
//    world_destroy();            
            
    DeleteObject(mem_bitmap);
    DeleteDC(memdc);   
}
/* End of system_shutdown */




void system_draw( HWND hwnd  )
{
    RECT client_rect;

    GetClientRect(hwnd, &client_rect);
    
    Rectangle(memdc, client_rect.left, client_rect.top,
                     client_rect.right, client_rect.bottom);

     draw_kimchain(memdc);
}


/* Called when a key is pressed */
void key_down(HWND hwnd, WPARAM w)
{
    // Mark key as pressed
    keys[w & 0xff] = true;  

    // Deal with single press events herex
   // if (keys['N'])
//    {
//        world_free_markers();
//        world_free_impacts();
////    }


if (keys['S']) in_save_mode = !in_save_mode;



    if (in_save_mode)
    {
        in_save_mode = false;

        if (keys['1'])  save_position(0); else
        if (keys['2'])  save_position(1); else
        if (keys['3'])  save_position(2); else
        if (keys['4'])  save_position(3); else
        if (keys['5'])  save_position(4); else
        if (keys['6'])  save_position(5); else
        if (keys['7'])  save_position(6); else
        if (keys['8'])  save_position(7); else
        if (keys['9'])  save_position(8); else
        if (keys['0'])  save_position(9); else
        

        in_save_mode = true;
        
    } else
    {
        if (keys['1'])  move_position(0);        
        if (keys['2'])  move_position(1);        
        if (keys['3'])  move_position(2);        
        if (keys['4'])  move_position(3);        
        if (keys['5'])  move_position(4);        
        if (keys['6'])  move_position(5);        
        if (keys['7'])  move_position(6);        
        if (keys['8'])  move_position(7);        
        if (keys['9'])  move_position(8);        
        if (keys['0'])  move_position(9);        
        
    }


    
//    if (keys['V']) robot.draw_vision = !robot.draw_vision;

    if (keys[27]) PostQuitMessage(0);


    
//     if (keys['1']) world.scale1 -= 0.01;
//     if (keys['2']) world.scale1 += 0.01;

//     if (keys['3']) world.scale2 -= 0.01;
//     if (keys['4']) world.scale2 += 0.01;
     
//      if (keys['5']) world.scale3 -= 0.001;
//     if (keys['6']) world.scale3 += 0.001;
     
      
    
      
}
/* End of key_down */


/* Called when a key is released */
void key_up(WPARAM w)
{
    keys[w & 0xff] = false;            
}
/* End of key up */



/* Process currently pressed keys */
void check_keys( void )
{
    // Decode WASD keys for manual override

                         // No key, stop

//     if (keys['A'])   blocks[0].x_pos -= 0.01;
//     if (keys['D'])   blocks[0].x_pos += 0.01;

//     if (keys['W'])   blocks[0].y_pos -= 0.01;
//     if (keys['S'])   blocks[0].y_pos += 0.01;
        
//     if (keys['Q'])   blocks[0].angle -= 0.01;
//     if (keys['A'])   blocks[0].angle += 0.01;

 /*    if (keys['Q'])   blocks[1].angle -= 0.01;
     if (keys['A'])   blocks[1].angle += 0.01;

     if (keys['W'])   blocks[2].angle -= 0.01;
     if (keys['S'])   blocks[2].angle += 0.01;

     if (keys['E'])   blocks[3].angle -= 0.01;
     if (keys['D'])   blocks[3].angle += 0.01;

     if (keys['R'])   blocks[4].angle -= 0.01;
     if (keys['F'])   blocks[4].angle += 0.01;

     if (keys['T'])  { blocks[5].angle -= 0.01;blocks[6].angle += 0.01;}
     if (keys['G'])  { blocks[5].angle += 0.01;blocks[6].angle -= 0.01;}*/


//     if (keys['U'])  { blocks[5].y_pos-= 0.01;blocks[6].y_pos += 0.01;}
//     if (keys['J'])  { blocks[5].y_pos += 0.01;blocks[6].y_pos -= 0.01;}


//     if (keys['U'])   blocks[6].angle -= 0.01;
//     if (keys['J'])   blocks[6].angle += 0.01;


     if (keys[VK_LEFT])   blocks[0].x_pos -= 0.01;
     if (keys[VK_RIGHT])   blocks[0].x_pos += 0.01;

     if (keys[VK_UP])   blocks[0].y_pos -= 0.01;
     if (keys[VK_DOWN])   blocks[0].y_pos += 0.01;


     
}
/* End of check keys */


/* Deal with the system timer */
void timer_message(HWND hwnd, WPARAM wparam)
{
    if (wparam == UPDATE_ID)
    {
    pos_step();

        calc_kimchain();


        check_keys();
        system_draw(hwnd);

//        world_update();
//        world_draw(memdc);
        
//        updates++;
        InvalidateRect(hwnd, NULL, 0);                            
        return;
    }

    if (wparam == SECOND_ID)
    {
//        updates_per_second = updates;
//        updates = 0;

      //  world_debug_update();      
    }            
}
/* End of timer_message */


/* Deal with paint message */
void window_paint(HWND hwnd)
{
    PAINTSTRUCT ps;
    HDC hdc = BeginPaint(hwnd, &ps);

    char buff[400] = "";

//    if (show_stats)
           
           if (in_save_mode)
           {
         strcat(buff, "In save Mode");       
        }
                       
       TextOut(memdc, 1, 1, buff, strlen(buff)); 


    // Copy memory device context to display 
    BitBlt(hdc, 0, 0, display_x, display_y, memdc, 0, 0, SRCCOPY);
            
    EndPaint(hwnd, &ps); 
    
  // InvalidateRect(neuron_window, NULL, 0);      
}
/* Wnd of window_paint */



/* Setup the off screen drawing system */
void memdc_setup( HWND hwnd )
{
    RECT r;
    GetClientRect(hwnd, &r);

    // Update stored client area size
    display_x = r.right;
    display_y = r.bottom;



    HDC hdc = GetDC(hwnd);

    // Create memory device context and bitmap            
    memdc = CreateCompatibleDC(hdc);
    mem_bitmap = CreateCompatibleBitmap(hdc, r.right, r.bottom);
            
    // Select the bitmap into the memort dc
    SelectObject(memdc, mem_bitmap);
            
    ReleaseDC(hwnd, hdc);     
}
/* End of memdc_setup */



double get_angle(int x,int y, unsigned int index)
{
    if (index < 0) return(0);

    double x_diff =  x  - get_screen_x(blocks[index].rot_pos.x);
    double y_diff =  y  - get_screen_y(blocks[index].rot_pos.y);
            
    return(atan2(y_diff , x_diff));    
}


/* Window function */
LRESULT CALLBACK main_win_proc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
    switch(message)
    {
        case WM_TIMER: timer_message(hwnd, wparam); return(0);

        case WM_CREATE: system_startup(hwnd); return(0);

        case WM_PAINT: window_paint(hwnd); return(0);

        case WM_DESTROY: 
            system_shutdown();            
            PostQuitMessage(0);
            return(0);
                                        
        case WM_SIZE:               // Process size message
            // These are alreadt setup, delete them
            DeleteObject(mem_bitmap);
            DeleteDC(memdc);


          
            // Setup again with the new size
            memdc_setup(hwnd);
            return(0);
                
        case WM_KEYDOWN:            // Process keydown
            key_down(hwnd, wparam);
            return(0);
    
        case WM_KEYUP:              // Process keyup
            key_up(wparam);
            return(0);
                
        case WM_LBUTTONDOWN:
            mouse_down = true;
            mouse_down_x = LOWORD(lparam);
            mouse_down_y = HIWORD(lparam);


            joint_index  = find_closest_joint(mouse_down_x, mouse_down_y);
 
           joint_angle =  blocks[joint_index].angle;//get_angle( mouse_down_x, mouse_down_y, mouse_down_index);
           mouse_angle = get_angle( mouse_down_x, mouse_down_y, joint_index);
        

            return(0);
               
        case WM_LBUTTONUP:
            mouse_down = false;
            return(0);
                          
        case WM_MOUSEMOVE:
            if (mouse_down && joint_index > -1)
            {
                int cur_x = LOWORD(lparam);
                int cur_y = HIWORD(lparam);               
                  
                 double x_diff = (cur_x - mouse_down_x) * 0.01;
                 double y_diff = (cur_y - mouse_down_y) * 0.01;
                  
                 mouse_down_x = cur_x;
                 mouse_down_y = cur_y;
                  
                 blocks[joint_index].angle =  joint_angle + (get_angle( mouse_down_x, mouse_down_y, joint_index) - mouse_angle);
                 
                 if (  blocks[joint_index].angle > M_PI) 
                  blocks[joint_index].angle  -= M_PI;
                  
                 
            }
            return(0);
                        
        case WM_RBUTTONDOWN:
            return(0);
                                      
        case WM_RBUTTONUP:
            return(0);
                                
        case WM_COMMAND:
            return(0);
            
                
        default:
            return(DefWindowProc(hwnd, message, wparam, lparam));    
    }
    return(0);
}
/* Wnd of window function */




/* Winmain */
int WINAPI WinMain(HINSTANCE hinst, HINSTANCE pinst, LPSTR args, int mode)
{
    char name[] = "Kinamtic Simulator (C) 2006 Jason Hunt";
    
    WNDCLASS wc;
    
    wc.hInstance = hinst;
    wc.lpszClassName = name;
    wc.lpfnWndProc = main_win_proc;
    wc.style = 0;
    
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.lpszMenuName = NULL;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    
    wc.hbrBackground = NULL;
    
    if (!RegisterClass(&wc)) return(0);
    
    HWND hwnd = CreateWindow(name, name, WS_OVERLAPPEDWINDOW, 
                            120, 120, // x, y
                            640,480, // height, width
                            HWND_DESKTOP, NULL, hinst, NULL);
                            
    ShowWindow( hwnd, mode);
    UpdateWindow( hwnd );

    MSG msg;

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
        
    return (msg.wParam);
}
/* End of winmain */









